> For the complete documentation index, see [llms.txt](https://docs.saddle.finance/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.saddle.finance/solidity-docs/helper/test/testswapreturnvalues.md).

# TestSwapReturnValues

## Functions:

* [`constructor(contract ISwap swapContract, contract IERC20 lpTokenContract, uint8 numOfTokens)`](#TestSwapReturnValues-constructor-contract-ISwap-contract-IERC20-uint8-)
* [`test_swap(uint8 tokenIndexFrom, uint8 tokenIndexTo, uint256 dx, uint256 minDy)`](#TestSwapReturnValues-test_swap-uint8-uint8-uint256-uint256-)
* [`test_addLiquidity(uint256[] amounts, uint256 minToMint)`](#TestSwapReturnValues-test_addLiquidity-uint256---uint256-)
* [`test_removeLiquidity(uint256 amount, uint256[] minAmounts)`](#TestSwapReturnValues-test_removeLiquidity-uint256-uint256---)
* [`test_removeLiquidityImbalance(uint256[] amounts, uint256 maxBurnAmount)`](#TestSwapReturnValues-test_removeLiquidityImbalance-uint256---uint256-)
* [`test_removeLiquidityOneToken(uint256 tokenAmount, uint8 tokenIndex, uint256 minAmount)`](#TestSwapReturnValues-test_removeLiquidityOneToken-uint256-uint8-uint256-)

## Function `constructor(contract ISwap swapContract, contract IERC20 lpTokenContract, uint8 numOfTokens)` <a href="#testswapreturnvalues-constructor-contract-iswap-contract-ierc20-uint8" id="testswapreturnvalues-constructor-contract-iswap-contract-ierc20-uint8"></a>

No description

## Function `test_swap(uint8 tokenIndexFrom, uint8 tokenIndexTo, uint256 dx, uint256 minDy)` <a href="#testswapreturnvalues-test_swap-uint8-uint8-uint256-uint256" id="testswapreturnvalues-test_swap-uint8-uint8-uint256-uint256"></a>

No description

## Function `test_addLiquidity(uint256[] amounts, uint256 minToMint)` <a href="#testswapreturnvalues-test_addliquidity-uint256-uint256" id="testswapreturnvalues-test_addliquidity-uint256-uint256"></a>

No description

## Function `test_removeLiquidity(uint256 amount, uint256[] minAmounts)` <a href="#testswapreturnvalues-test_removeliquidity-uint256-uint256" id="testswapreturnvalues-test_removeliquidity-uint256-uint256"></a>

No description

## Function `test_removeLiquidityImbalance(uint256[] amounts, uint256 maxBurnAmount)` <a href="#testswapreturnvalues-test_removeliquidityimbalance-uint256-uint256" id="testswapreturnvalues-test_removeliquidityimbalance-uint256-uint256"></a>

No description

## Function `test_removeLiquidityOneToken(uint256 tokenAmount, uint8 tokenIndex, uint256 minAmount)` <a href="#testswapreturnvalues-test_removeliquidityonetoken-uint256-uint8-uint256" id="testswapreturnvalues-test_removeliquidityonetoken-uint256-uint8-uint256"></a>

No description


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.saddle.finance/solidity-docs/helper/test/testswapreturnvalues.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
